GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
Learn::AdversarialJob Class Reference

This class embeds roots for the simulations. More...

`#include <adversarialJob.h>`

Inheritance diagram for Learn::AdversarialJob:

## Public Member Functions
| AdversarialJob ()=delete
| Deleted default constructor.
| AdversarialJob (std::initializer_list< const TPG::TPGVertex * > roots, uint64_t archiveSeed=0, uint64_t idx=0, int16_t posOfStudiedRoot=-1)
| Constructor enabling storing elements in the job so that the Learning Agents will be able to use them later.
void | addRoot (const TPG::TPGVertex *root)
| Adds a root to this job and updates the size of the job.
size_t | getSize () const
| Getter of the number of roots.
std::vector< const TPG::TPGVertex * > | getRoots () const
| Getter of the roots.
const TPG::TPGVertex * | getRoot () const override
| Getter of the first root.
const TPG::TPGVertex * | operator[] (int i) const
| Getter of a single root in the list.
virtual const int16_t | getPosOfStudiedRoot () const
| Getter of the posOfStudiedRoot.
Public Member Functions inherited from Learn::Job
| Job ()=delete
| Deleted default constructor.
| Job (const TPG::TPGVertex *root, uint64_t archiveSeed=0, uint64_t idx=0)
| Constructor enabling storing elements in the job so that the Learning Agents will be able to use them later.
virtual | ~Job ()=default
| Default virtual destructor.
uint64_t | getIdx () const
| Getter of index.
uint64_t | getArchiveSeed () const
| Getter of archiveSeed.

## Protected Attributes
std::vector< const TPG::TPGVertex * > | roots
const int16_t | posOfStudiedRoot
Protected Attributes inherited from Learn::Job
const TPG::TPGVertex * | root
const uint64_t | idx
const uint64_t | archiveSeed

## Detailed Description

This class embeds roots for the simulations.

The goal of the AdversarialJob is to contain several roots, so that each job will match with one simulation/evaluation. An adversarial learning agent will embed for example 2 roots per job to simulate 2 agents activities (like a tic-tac-toe).

## Constructor & Destructor Documentation

## ◆ AdversarialJob()

Learn::AdversarialJob::AdversarialJob | ( | std::initializer_list< const TPG::TPGVertex * > | roots,
|  | uint64_t | archiveSeed = 0,
|  | uint64_t | idx = 0,
|  | int16_t | posOfStudiedRoot = -1 )
| inline

Constructor enabling storing elements in the job so that the Learning Agents will be able to use them later.

Parameters

  [in] | roots | The roots that will be encapsulated into the job.
  [in] | archiveSeed | The archive seed that will be used with this job.
  [in] | idx | The index of this job.
  [in] | posOfStudiedRoot | The position of the root we will have to check the score. Equal to -1 if all roots have to be checked.

## Member Function Documentation

## ◆ addRoot()

void Learn::AdversarialJob::addRoot | ( | const TPG::TPGVertex * | root | ) |

Adds a root to this job and updates the size of the job.

Parameters

  [in] | root | The root that will be added to this job.

Copyright or © or Copr. IETR/INSA - Rennes (2019 - 2020) :

Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2019 - 2020) Pierre-Yves Le Rolland-Raumer plero.nosp@m.lla@.nosp@m.insa-.nosp@m.renn.nosp@m.es.fr (2020)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

## ◆ getPosOfStudiedRoot()

const int16_t Learn::AdversarialJob::getPosOfStudiedRoot | ( |  | ) | const
| virtual

Getter of the posOfStudiedRoot.

Returns
  The position of the evaluated root.

## ◆ getRoot()

const TPG::TPGVertex * Learn::AdversarialJob::getRoot | ( |  | ) | const
| override virtual

Getter of the first root.

Returns
  The first root embedded by the job.

Reimplemented from Learn::Job.

## ◆ getRoots()

std::vector< const TPG::TPGVertex * > Learn::AdversarialJob::getRoots | ( |  | ) | const

Getter of the roots.

Returns
  The vector containing the roots of the job.

## ◆ getSize()

size_t Learn::AdversarialJob::getSize | ( |  | ) | const

Getter of the number of roots.

Returns
  The number of roots in this job.

## ◆ operator[]()

const TPG::TPGVertex * Learn::AdversarialJob::operator[] | ( | int | i | ) | const

Getter of a single root in the list.

Parameters

  [in] | i | The wanted index in the list of roots.

Returns
  The root found at index i.

## Member Data Documentation

## ◆ posOfStudiedRoot

const int16_t Learn::AdversarialJob::posOfStudiedRoot
| protected

Position of the root that is to be evaluated. Equal to -1 if there is no one. That's typically useful if we have e.g. 4 champions and a root to evaluate in the job : we can skip the champions and just look at the score of the root.

See AdversarialLearningAgent.evaluateAllRootsInParallelCompileResults() for further understandings of its usage.

## ◆ roots

std::vector<const TPG::TPGVertex*> Learn::AdversarialJob::roots
| protected

The roots contained in the job. e.g. 2 roots that will compete together in a 1vs1 game.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/learn/adversarialJob.h
- D:/a/gegelati/gegelati/gegelatilib/src/learn/adversarialJob.cpp